{Unita na vykraslenie PCX obrazku, navod :
  PalettePCX('menoobrazku.pcx', PouzitPaletu, Paleta);
  DrawPCX('menoobrazku.pcx', SuradnicaVykresleniaX, SuradnicaVykresleniaY);

  ;
  ;
  Najprv treba nacitat paletu. Teda :
    PalettePCX('obr.pcx', 1, Paleta);
  pricom [PouzitPaletu] znamena, ci sa nacitana paleta pouzije.
  [Paleta] je pole [0..256*3-1] of Byte, kde sa paleta zapise.
}
Unit PCXUnit;

Interface

Procedure DrawPCX(Name: String; XSub, YSub : Word);
Procedure PalettePCX(Name : String; Use : Byte; var RGB_Palette : Array of Byte);

Implementation

Uses
  Graph;

Const
  BufferSize = 4096;

Type
  HeaderTyp = RECORD
    Kennung,
    Version,
    Kodierung,
    Bits_Pixel  :  Byte;
    X_Start,
    Y_Start,
    X_Ende,
    Y_Ende,
    X_Auloesung,
    Y_Auloesung  :  Word;
    Palette_16  :  ARRAY[1..48] OF Byte;
    Reserviert,
    Anz_Ebenen  :  Byte;
    Bytes_Zeile,
    Paletten_Typ  :  Word;
    Dummy  :  ARRAY[1..58] OF Byte;
  END;

Var


  NumRead, Counter: Word;
  Header: HeaderTyp;
  X_Ende_2: Word;
  Lauf1, Lauf2, X, Y: Word;
  Datei:  File;
  Buffer:  ARRAY[1..BufferSize] OF Byte;
  Farbe, Faktor:  Byte;


Procedure Abort(Msg: String);
begin
  Writeln(Msg);
  Writeln;
  halt;
end;

Procedure PalettePCX(Name : String; Use : Byte; var RGB_Palette : Array of Byte);
Begin
  Assign(Datei, Name);
  {$I-}
    Reset(Datei, 1);
  {$I+}
  Case IOResult of
    2: Abort('ERROR: File not found - '+ParamStr(1));
    3: Abort('ERROR: Path not found!');
    5: Abort('ERROR: Access denied - cannot open pcx-file!');
    8: Abort('ERROR: Not enough memory to open file!');
  end;

  BlockRead(Datei, Header, SizeOf(Header), NumRead);
  If NumRead <> SizeOf(Header) then
    Abort('ERROR: PCX-Header damaged!');

  X_Ende_2:= Header.Bytes_Zeile;

  If Header.Kennung <> 10 then Abort('ERROR: Inputfile is NOT a valid PCX-File!');
  If Header.Version <> 5 then Abort('ERROR: Wrong PCX-Version!');

  If (Header.Bits_Pixel = 8) and (Header.Anz_Ebenen = 3) then
    Abort('ERROR: 24-Bit images are NOT supported!');

  If (Header.Bits_Pixel = 1) and (Header.Anz_Ebenen = 4) then
    Abort('ERROR: 16 color images are NOT supported!');

  If (Header.Bits_Pixel = 1) and (Header.Anz_Ebenen = 1) then
    Abort('ERROR: 2 color images are NOT supported!');

  Seek(Datei, FileSize(Datei)-256*3-1);
  BlockRead(Datei, Buffer, 256*3+1);
  Lauf1:= 1;
    FOR Lauf2 := 0 TO 255 DO
     BEGIN
        RGB_Palette[Lauf2*3] := Buffer[1+Lauf1] div 4;
        RGB_Palette[Lauf2*3+1] := Buffer[1+Lauf1+1] div 4;
        RGB_Palette[Lauf2*3+2] := Buffer[1+Lauf1+2] div 4;
        Inc(Lauf1, 3);
     END;

  If (Use=1) then
  ASM
    MOV AH, 10h
    MOV AL, 12h
    XOR BX, BX
    MOV CX, 100h {???}
    MOV DX, Seg(RGB_Palette)
    MOV ES, DX
    MOV DX, Offset(RGB_Palette)
    INT 10h
  END;
End;

Procedure DrawPCX(Name: String; XSub, YSub : Word);
begin
  Assign(Datei, Name);
  {$I-}
    Reset(Datei, 1);
  {$I+}
  Case IOResult of
    2: Abort('ERROR: File not found - '+ParamStr(1));
    3: Abort('ERROR: Path not found!');
    5: Abort('ERROR: Access denied - cannot open pcx-file!');
    8: Abort('ERROR: Not enough memory to open file!');
  end;

  BlockRead(Datei, Header, SizeOf(Header), NumRead);
  If NumRead <> SizeOf(Header) then
    Abort('ERROR: PCX-Header damaged!');

  X_Ende_2:= Header.Bytes_Zeile;

  If Header.Kennung <> 10 then Abort('ERROR: Inputfile is NOT a valid PCX-File!');
  If Header.Version <> 5 then Abort('ERROR: Wrong PCX-Version!');

  If (Header.Bits_Pixel = 8) and (Header.Anz_Ebenen = 3) then
    Abort('ERROR: 24-Bit images are NOT supported!');

  If (Header.Bits_Pixel = 1) and (Header.Anz_Ebenen = 4) then
    Abort('ERROR: 16 color images are NOT supported!'); 

  If (Header.Bits_Pixel = 1) and (Header.Anz_Ebenen = 1) then
    Abort('ERROR: 2 color images are NOT supported!');

  Seek(Datei, FileSize(Datei)-256*3-1);
  BlockRead(Datei, Buffer, 256*3+1);

  Seek(Datei, 128);      { Jump to the end of the pcx-header }

  Y:= 0;
  X:= 0; 

  Counter:= 4096; 

  While (Y < Header.Y_Ende+1) do
  begin
    Inc(Counter);
    If Counter > BufferSize then
    begin
      BlockRead(Datei, Buffer, BufferSize, NumRead);
      Counter:= 1;
    end;

    If Buffer[Counter] >= 192 then
    begin
      Faktor:= Buffer[Counter]-192;
      Inc(Counter);
      If Counter > BufferSize then
      begin
        BlockRead(Datei, Buffer, BufferSize, NumRead);
        Counter:= 1;
      end;
      Farbe:= Buffer[Counter];
    end
    else
    begin
      Faktor:= 1;
      Farbe:= Buffer[Counter];
    end;

    For Lauf1:= 1 to Faktor do
    begin
      If X = X_Ende_2 then
      begin
        Inc(Y);
        X:= 0;
      end;
      if (X < X_Ende_2-1) and (Y < Header.Y_Ende) then
        PutPixel( X+XSub,Y+YSub, Farbe );
      Inc(X)
    end;
  end;
  Close(Datei);
End;

Begin
End.